lappend auto_path [pwd]
package require wx

set path [pwd]/demo

catch { wm withdraw . }

# the wx prefix is mandatory because we mix wxWindows and TK code here
# if you don't need TK you can make a "namespace import wx::*" 

# wx::toplevel is compatible with TK but it has extras ...
wx::toplevel .wx -title "wx for Tcl demo 0.3"

# ok menus are not comptaible with TK ... the menu interface 'll soon
# be compatible ...

wx::menubar .wx.menubar
wx::menu .wx.menubar.file -text "File"
wx::menuitem .wx.menubar.file.open -text "About" 
wx::menuseparator .wx.menubar.file.dummy1
wx::menuitem .wx.menubar.file.exit -text "Exit" -command exit

wx::panedwindow .wx.paned
set t .wx.paned.tree 

set demos {
	{ "buttons.tcl" "Buttons" }
	{ "controls.tcl" "Check & Radio & Spin" }
	{ "combobox.tcl" "Combobox" }
	{ "listbox.tcl" "Listbox" }
	{ "geometry.tcl" "Geometry management" }
	{ "dialogs.tcl" "Common dialogs" }
	{ "tree.tcl" "TreeView" }
	{ "embed.tcl" "TK widgets embedding" }
}

wx::tree $t -width 32 -height 32 -selchangedcommand {
	set key [$t getselection]

	if { $key != $root } {
		.wx.paned.nb.f2.code load "$path/$demo_file($key)"
		source "$path/$demo_file($key)"
	}
}

set root [$t addroot "wx demos"]

foreach demo $demos {
	set key [$t append [lindex $demo 1] $root]
	set demo_file($key) [lindex $demo 0] 
}

$t expand $root

wx::notebook .wx.paned.nb 

wx::frame .wx.paned.nb.f1
.wx.paned.nb add .wx.paned.nb.f1 "Demo"

wx::frame .wx.paned.nb.f2
.wx.paned.nb add .wx.paned.nb.f2 "Code"

wx::text .wx.paned.nb.f2.code
wx::pack .wx.paned.nb.f2.code -fill both -expand 1

.wx.paned splitvertical .wx.paned.tree .wx.paned.nb
.wx.paned setsashposition 200

wx::pack .wx.paned -fill both -expand 1

# wx::loop is not mandatory but needed to get some extras working (eg tooltips)
# but events are faster in a canvas without it

wx::loop

